----
-- $Rev: 63 $:     Revision der letzten Änderung
-- $Author: FoxAlpha $:  Author der letzten Änderung
-- $Date: 2014-11-20 22:49:28 +0100 (Do, 20. Nov 2014) $:    Date der letzten Änderung
----

----
--	Konsolenbefehlen
----

----
-- Registrieren der Konsolenbefehle
----
function ClockMod:registerConsoleCmd()
	
	addConsoleCommand("ClockMod", "Enable and disable the whole ClockMod", "ClockModCmd", self);
	addConsoleCommand("ClockModHelp", "Shows full Commandlist", "ClockModHelp", self);
	addConsoleCommand("ClockModDebug", "Shows some debug information variables", "ClockModDebug", self);
	addConsoleCommand("ClockModDefault", "Sets all values to default values", "ClockModDefault", self);
	addConsoleCommand("ClockModPanel", "Enable and disable the ClockMod Panel [true|false]", "ClockModPanel", self);
	addConsoleCommand("ClockModPanelCompass", "Enable and disable the ClockMod Panel Compass [true|false]", "ClockModPanelCompass", self);
	addConsoleCommand("ClockModPanelMove", "Enable and disable draging for Panel [true|false]", "ClockModPanelMove", self);
	addConsoleCommand("ClockModPanelPos", "Sets the panel position [x,y,w]", "ClockModPanelPos", self);
	addConsoleCommand("ClockModReload", "Reloads the configurationfiles", "ClockModReload", self);
	addConsoleCommand("ClockModSave", "Saves the configuration", "ClockModSave", self);
	addConsoleCommand("ClockModColorDate", "sets the fontcolor for the Date", "ClockModColorDate", self);
	addConsoleCommand("ClockModColorDateRGB", "sets the fontcolor for the Date as RGB values 0-255", "ClockModColorDateRGB", self);
	addConsoleCommand("ClockModColorTime", "sets the fontcolor for the Time", "ClockModColorTime", self);
	addConsoleCommand("ClockModColorTimeRGB", "sets the fontcolor for the Time as RGB values 0-255", "ClockModColorTimeRGB", self);
	addConsoleCommand("ClockModColorTitle", "sets the fontcolor for the Title of Playtime", "ClockModColorTitle", self);
	addConsoleCommand("ClockModColorTitleRGB", "sets the fontcolor for the Title of Playtime as RGB values 0-255", "ClockModColorTitleRGB", self);
	addConsoleCommand("ClockModColorText", "sets the fontcolor for the Playtime", "ClockModColorText", self);
	addConsoleCommand("ClockModColorTextRGB", "sets the fontcolor for the Title of Playtime as RGB values 0-255", "ClockModColorTextRGB", self);
	addConsoleCommand("ClockModColorCompass", "sets the fontcolor for the Compass", "ClockModColorCompass", self);
	addConsoleCommand("ClockModColorCompassRGB", "sets the fontcolor for the Compass as RGB values 0-255", "ClockModColorCompassRGB", self);
	addConsoleCommand("ClockModFontSize", "sets the fontsize 0-1", "ClockModFontSize", self);
	addConsoleCommand("ClockModFontIndent", "sets the font indent 0-1", "ClockModFontIndent", self);
	-- addConsoleCommand("ClockModAlarm", "Sets an alarm at given time", "ClockModAlarm", self);
	-- addConsoleCommand("ClockModTimer", "Sets a countdown of given minutes", "ClockModTimer", self);
	
end;
----

----
--	Funktion für Debug ausgaben
----
function ClockMod:ClockModDebug(Parameter)
	if Parameter ~= nil then
		if tostring(Parameter) == "txtColors" then
			print(table.show(self.txtColors, "self.txtColors"));
		end;
		if tostring(Parameter) == "cmPanel" then
			print(table.show(self.cmPanel, "self.cmPanel"));
		end;
		if tostring(Parameter) == "default" then
			print(table.show(self.default, "self.default"));
		end;
	else
		print(table.show(self.txtColors, "self.txtColors"));
		print(table.show(self.cmPanel, "self.cmPanel"));
		print(table.show(self.default, "self.default"));
	end;
end;
----

----
-- Hilfe zu den einzelnen Befehlen anzeigen
----
function ClockMod:ClockModHelp(Parameter)

	if Parameter ~= nil then
		if Parameter == "ClockMod" then
			self:ClockMod("help");
		end;
		
		if Parameter == "ClockModDefault" then
			self:ClockModDefault("help");
		end;
		
		if Parameter == "ClockModPanel" then
			self:ClockModPanel("help");
		end;
		
		if Parameter == "ClockModPanelCompass" then
			self:ClockModPanelCompass("help");
		end;
		
		if Parameter == "ClockModPanelMove" then
			self:ClockModPanelMove("help");
		end;
		
		if Parameter == "ClockModPanelPos" then
			self:ClockModPanelPos("help");
		end;

		if Parameter == "ClockModReload" then
			self:ClockModReload("help");
		end;
		
		if Parameter == "ClockModSave" then
			self:ClockModSave("help");
		end;
		
		if Parameter == "ClockModColorDate" then
			self:ClockModColorDate("help");
		end;
		
		if Parameter == "ClockModColorDateRGB" then
			self:ClockModColorDateRGB("help");
		end;
		
		if Parameter == "ClockModColorTime" then
			self:ClockModColorTime("help");
		end;
		
		if Parameter == "ClockModColorTimeRGB" then
			self:ClockModColorTimeRGB("help");
		end;
		
		if Parameter == "ClockModColorTitle" then
			self:ClockModColorTitle("help");
		end;
		
		if Parameter == "ClockModColorTitleRGB" then
			self:ClockModColorTitleRGB("help");
		end;
		
		if Parameter == "ClockModColorText" then
			self:ClockModColorText("help");
		end;
		
		if Parameter == "ClockModColorTextRGB" then
			self:ClockModColorTextRGB("help");
		end;
		
		if Parameter == "ClockModColorCompass" then
			self:ClockModColorCompass("help");
		end;
		
		if Parameter == "ClockModColorCompassRGB" then
			self:ClockModColorCompassRGB("help");
		end;
		
		if Parameter == "ClockModFontSize" then
			self:ClockModSize("help");
		end;

		if Parameter == "ClockModFontIndent" then
			self:ClockModFontIndent("help");
		end;
		
		-- if Parameter == "ClockModAlarm" then
			-- self:ClockModAlarm("help");
		-- end;
		
		-- if Parameter == "ClockModTimer" then
			-- self:ClockModTimer("help");
		-- end;

	else
		-- TODO: Übersetzen, Hilfe kurztexte
		print("---- ClockMod Hilfe ----");
		print(string.format("|| %s || Version: %s ||", g_i18n:getText("clockmodtxt"), self.cmVersion));
		print("Tippe ClockModHelp [Befehl] ein um eine Detailierte Hilfe zu den Parametern zu bekommen");
		print("ClockMod: Zeigt den Status oder aktiviert / deaktiviert den ClockMod.");
		print("ClockModDefault: Setzt alle Werte auf ausgangswerte zurück");
		print("ClockModPanel: Zeigt den Status oder aktiviert / deaktiviert die Anzeige innerhalb der Uhr oder in einem eigenen Panel.");
		print("ClockModPanelCompass: Aktiviert / deaktiviert die Anzeige eines Kompass im Panel.");
		print("ClockModPanelMove: Aktiviert / deaktiviert den Mauszeiger mit dem das Panel dann verschoben werden kann.");
		print("ClockModPanelPos: Passt die x, y Position und mit w die Breite des Panels an");
		print("ClockModReload: Lädt die Konfigurationsdatei neu ein.");
		print("ClockModSave: Speichert alle Werte in der Konfigurationsdatei");
		print("ClockModColorDate: Setzt die Farbwerte für das Datum");
		print("ClockModColorDateRGB: Setzt die Farbwerte für das Datum als RGB Werte (0-255)");
		print("ClockModColorTime: Setzt die Farbwerte für Zeit");
		print("ClockModColorTimeRGB: Setzt die Farbwerte für Zeit als RGB Werte (0-255)");
		print("ClockModColorTitle: Setzt die Farbwerte für Beschrifung");
		print("ClockModColorTitleRGB: Setzt die Farbwerte für Beschrifung als RGB Werte (0-255)");
		print("ClockModColorText: Setzt die Farbwerte für Spielzeit");
		print("ClockModColorTextRGB: Setzt die Farbwerte für Spielzeit als RGB Werte (0-255)");
		print("ClockModColorCompass: Setzt die Farbwerte für die Kompassanzeige");
		print("ClockModColorCompassRGB: Setzt die Farbwerte für die KOmpassanzeige als RGB Werte (0-255)");
		print("ClockModFontSize Setzt die Schriftgröße bei Anzeige im Panel ");
		print("ClockModFontIndent Setzt den Text Abstand innerhalb des Panels ");
		-- print("ClockModAlarm: Setzt einen Wecker auf eine Uhrzeit");
		-- print("ClockModTimer: Setzt einen Countdown in Minuten");
		print("---- ClockMod Hilfe ----");
	end;
	
end;
----

----
-- De-/Aktivieren des ClockMods
----
function ClockMod:ClockModCmd(Parameter)

	if Parameter ~= nil then
		if string.lower(Parameter) == "1" or string.lower(Parameter) == "true" then
			self.cmEnabled = true;
			
			if self.cmPanel.usePanel then
				self:updatePanelOverlays();
			end;

		elseif string.lower(Parameter) == "0" or string.lower(Parameter) == "false" then
			self.cmEnabled = false;
		elseif string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			print("ClokMod Mögliche Werte: 1|0 oder true|false aktiviert oder deaktiviert den gesamten ClockMod");
			print("Beispiel: ClockMod 0");
			print("Deaktiviert den gesamten ClockMod");
			print("Beispiel: ClockMod 1");
			print("^Aktiviert den gesamten ClockMod");
		end;		
	end;
	if self.cmEnabled then 
		return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModIsEnabled"));
	else
		return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModIsDisabled"));
	end;

end;
----

----
-- Zurücksetzen aller Werte auf Standard
----
function ClockMod:ClockModDefault(Parameter)
	if Parameter ~= nil then
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen
			print("Setzt alle Werte auf standard Werte zurück");
			print("und speichert diese in der Konfigurationsdatei ab");
			print("Die vorhandene Konfiguration wird überschrieben");
		end;
	else
		self.txtColors = nil;
		self.txtColors = {};
		self.txtColors = table.tcopy(self.default.colors);
		self.cmPanel = nil;
		self.cmPanel = {};
		self.cmPanel = table.tcopy(self.default.panel);
		-- self.cmAlarm = self.default.alarm;
		-- self.cmCounter = self.default.timer;

		if self.Debug.active then
			print("---- DEBUG ----");
			table.show(self.cmPanel, "cmPanel");
			print("---- DEBUG ----");
		end;
		
		if self.cmPanel.usePanel then
			self:updatePanelOverlays();
		end;
		
		self:saveClockModConfig();
		self:loadClockModConfig();
	end;
end;
----

----
-- De-/aktivieren der Ansicht in einem eigenen Panel
----
function ClockMod:ClockModPanel(Parameter)

	if Parameter ~= nil then
		if string.lower(Parameter) == "1" or string.lower(Parameter) == "true" then
			self.cmPanel.usePanel = true;
			self:updatePanelOverlays();
			print(g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelIsEnabled"));
		elseif string.lower(Parameter) == "0" or string.lower(Parameter) == "false" then
			self.cmPanel.usePanel = false;
			print(g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelIsDisabled"));
		elseif string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen ClockModPanel Hilfe
			print("ClokModPanel Mögliche Werte: 1|0 oder true|false aktiviert oder deaktiviert die Anzeige in einem eigenen Panel");
			print("Beispiel ClockModPanel 0");
			print("zeigt die Ausgabe innerhalb der Spieluhr an")
			print("Beispiel ClockModPanel 1");
			print("zeigt die Ausgabe innerhalb eines eigenen Panels unterhalb der Spieluhr an")
			print("Die Position des Panels kann in der Konfigurationsdatei und über ClockModPanelPos angepasst werden");
		end;
	else
		if self.cmPanel.usePanel then 
			return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelIsEnabled"));
		else
			return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelIsDisabled"));
		end;
	end;

end;
----

----
--	De-/Aktivieren Bewegen des Panels mit der Maus
----
function ClockMod:ClockModPanelMove(Parameter)
	if Parameter ~= nil then
		if string.lower(Parameter) == "1" or string.lower(Parameter) == "true" then
			-- ClockMod muss aktiv sein
			if not self.cmEnabled then
				return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelMoveEnablePanelFirst"));
			else	-- Wenn Aktiv, dann muss auch das Panel aktiv sein !!!
				if not self.cmPanel.usePanel then
					return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelMoveEnablePanelFirst"));
				end;
				----
				-- Dragging aktivieren
				----
				self.cmPanel.hudCanMove = true;
				self.checkMouseActive = true;

				InputBinding.setShowMouseCursor(self.cmPanel.hudCanMove);
				g_mouseControlsHelp.active = false; 
				InputBinding.wrapMousePositionEnabled = false; 
				if (g_currentMission.player.isEntered) then
					g_currentMission.player.isFrozen = true;
				end;
				----				
			end;
		elseif string.lower(Parameter) == "0" or string.lower(Parameter) == "false" then
			if not self.cmEnabled then
				return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelMoveEnablePanelFirst"));
			else	-- Wenn Aktiv, dann muss auch das Panel aktiv sein !!!
				if not self.cmPanel.usePanel then
					return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelMoveEnablePanelFirst"));
				end;
				----
				-- Dragging aktivieren
				----
				self.cmPanel.hudCanMove = false;
				self.checkMouseActive = false;

				InputBinding.setShowMouseCursor(self.cmPanel.hudCanMove);
				g_mouseControlsHelp.active = true; 
				InputBinding.wrapMousePositionEnabled = true; 
				if (g_currentMission.player.isEntered) then
					g_currentMission.player.isFrozen = false;
				end;
				----				
			end;
		elseif string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			print("-- ClockModPanelMove --");
			print("ClockModPanelMove Mögliche Werte: 1|0 oder true|false ");
			print("aktiviert oder deaktiviert das positionieren des Panels mit der Maus");
			print("Zum speichern der Position, ClockModSave in der Konsole ausführen");
			--print("");
			print("----");
		end;
	else
		if self.cmPanel.hudCanMove then 
			return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelMoveIsEnabled"));
		else
			return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelMoveIsDisabled"));
		end;
	end;
end;
----

----
-- De-/aktivieren des Kompass im Panel
----
function ClockMod:ClockModPanelCompass(Parameter)

	if not self.cmPanel.usePanel then 
		return (g_i18n:getText("clockmodtxt") .. " : Das Panel muss zuerst aktiviert werden. ClockModPanel 1");
	end;
	
	if Parameter ~= nil then
		if string.lower(Parameter) == "1" or string.lower(Parameter) == "true" then
			self.cmPanel.usePanelCompass = true;
			self.cmPanel.showCompass = true;
			self:reloadPanelOverlays();
			--self:updatePanelOverlays();
			print(g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelCompassIsEnabled"));
		elseif string.lower(Parameter) == "0" or string.lower(Parameter) == "false" then
			self.cmPanel.usePanelCompass = false;
			self:reloadPanelOverlays();
			print(g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelCompassIsDisabled"));
		elseif string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen ClockModPanelCompass Hilfe
			print("ClokModPanelCompass mögliche Werte: 1|0 oder true|false aktiviert oder deaktiviert die Anzeige des Kompass im Panel");
			print("Beispiel ClockModPanelCompass 1");
		end;
	else
		if self.cmPanel.usePanelCompass then 
			return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelCompassIsEnabled"));
		else
			return (g_i18n:getText("clockmodtxt") .. " : " .. g_i18n:getText("CM_ClockModPanelCompassIsDisabled"));
		end;
	end;

end;
----

----
-- Setzen der Panel Position
----
function ClockMod:ClockModPanelPos(Parameter)

	if Parameter ~= nil then
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen ClockModPanelPos Hilfe
			print("Ändert die Position des Panels");
			print("Beispiel: ");
			print("ClockModPanelPos x=0.5,y=0.5,w=0.18 | Mitte des Bildschirm und 256px breit");
			print("ClockModPanelPos r=1,g=1,b=1 | ändert nur die Farben");
			print("ClockModPanelPos r=1,g=1 | ändert nur den Rot und Grün anteil der Farbe");
			print("ClockModPanelPos r=1 | ändert nur den Rot Anteil der Farbe");
			return "";
		else
			for k, v in string.gfind(Parameter, "([xyw])=([0-9.]+)") do
				self.cmPanel.position[k] = tonumber(v);
				print("Neuer Wert : " .. k .. "=" .. v);
			end;
        end;
	else
		print("---- aktuelle Panel Position ----");
		print("Position X : " .. self.cmPanel.position.x);
		print("Position Y : " .. self.cmPanel.position.y);
		print("Breite W : " .. self.cmPanel.position.w);
		print("---- Panel Position ----");
	end;
	
end;
----

----
-- Neuladen der Konfigurationsdatei
----
function ClockMod:ClockModReload(Parameter)

	-- TODO: Übersetzen ClockModReload Hilfe
	if Parameter ~= nil then
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			print("Lädt die Konfigurationsdatei neu. Aufruf ohne Parameter.");
		end;
		return;
	end;

	if self:loadClockModConfig() then
		self:updatePanelOverlays();
	else
		print("Neuladen der Konfigurationsdatei fehlgeschlagen !");
	end;

end;
----

----
-- Speichern aller Werte in der Konfigurationsdatei
----
function ClockMod:ClockModSave(Parameter)

	-- TODO: Übersetzen ClockModSave Hilfe
	if Parameter ~= nil then
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			print("Speichert alle Werte in der Konfigurationsdatei. Aufruf ohne Parameter.");
		end;
		return;
	end;

	self:saveClockModConfig();

end;
----

----
-- Ausführung von Konsolen Befehlen
----
function ClockMod:ClockModColorDateRGB(Parameter)

	local myTable = {};

	if Parameter ~= nil then
		local pw = 0;
        for k, v in string.gfind(Parameter, "([rgba])=([0-9]+)") do
			pw = v/255;
            myTable[k] = tonumber(v);
        end;
		
		local tmp = "";
		for k,v in pairs(myTable) do
			tmp = tmp .. k .. "=" .. v .. ",";
		end;
		self:ClockModColorDate(tmp);

		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			ClockModColorDate(Parameter);
		end;
	end;

end;

----
-- Ausführung von Konsolen Befehlen
----
function ClockMod:ClockModColorDate(Parameter)

	if Parameter ~= nil then	
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen ClockModColorDate Hilfe
			print("Ändert die Farbe für die Datumsanzeige");
			print("Beispie: ");
			print("ClockModColorDate r=1,g=1,b=1,a=1 | ändert alle Farben und den Transparentswert der Schrift");
			print("ClockModColorDate r=1,g=1,b=1 | ändert nur die Farben");
			print("ClockModColorDate r=1,g=1 | ändert nur den Rot und Grün anteil der Farbe");
			print("ClockModColorDate r=1 | ändert nur den Rot Anteil der Farbe");
		else
			for k, v in string.gfind(Parameter, "([rgba])=([0-9.]+)") do
				if tonumber(v) > 1 then
					print("Der Farbwert sollte zwischen 0 und 1 liegen, Für RGB Werte bitte die Funktion ClockModColorDateRGB verwenden");
				else
					self.txtColors.date[k] = tonumber(v);
					print("Neuer Wert : " .. k .. "=" .. v);
				end;
			end;			
		end;
	else
        for k, v in pairs(self.txtColors.date) do
			-- TODO: Übersetzen ClockModColorDate
			print(string.format("Aktueller Wert Textfarbe für : %s=%.3f", k, v));
        end;
	end;

end;
----

----
-- Ausführung von Konsolen Befehlen
----
function ClockMod:ClockModColorTimeRGB(Parameter)

	local myTable = {};
	if Parameter ~= nil then
		local pw = 0;
        for k, v in string.gfind(Parameter, "([rgba])=([0-9]+)") do
			pw = v/255;
            myTable[k] = tonumber(v);
        end;
		local tmp = "";
		for k,v in pairs(myTable) do
			tmp = tmp .. k .. "=" .. v .. ",";
		end;
		self:ClockModColorTime(tmp);

		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			ClockModColorTime(Parameter);
		end;
	end;

end;

----
-- Ändert die Farbe der Schrift für die Zeitanzeige
----
function ClockMod:ClockModColorTime(Parameter)

	if Parameter ~= nil then
 		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen ClockModColorTime Hilfe
			print("Ändert die Farbe für die Zeitsanzeige");
			print("Beispiel: ");
			print("ClockModColorTime r=1,g=1,b=1,a=1 | ändert alle Farben und den Transparentswert der Schrift");
			print("ClockModColorTime r=1,g=1,b=1 | ändert nur die Farben");
			print("ClockModColorTime r=1,g=1 | ändert nur den Rot und Grün anteil der Farbe");
			print("ClockModColorTime r=1 | ändert nur den Rot Anteil der Farbe");
		else
		   for k, v in string.gfind(Parameter, "([rgba])=([0-9.]+)") do
				if tonumber(v) > 1 then
					print("Der Farbwert sollte zwischen 0 und 1 liegen, Für RGB Werte bitte die Funktion ClockModColorTimeRGB verwenden");
				else
					self.txtColors.time[k] = tonumber(v);
					print(string.format("Neuer Farbe für : %s=%.3f", k, v));
				end;
			end;
		end;
	else
        for k, v in pairs(self.txtColors.time) do
			print(string.format("Aktueller Wert Textfarbe für : %s=%.3f", k, v));
        end;
	end;

end;
----

----
-- Ausführung von Konsolen Befehlen
----
function ClockMod:ClockModColorTitleRGB(Parameter)

	local myTable = {};
	if Parameter ~= nil then
		local pw = 0;
        for k, v in string.gfind(Parameter, "([rgba])=([0-9]+)") do
			pw = v/255;
            myTable[k] = tonumber(v);
        end;
		local tmp = "";
		for k,v in pairs(myTable) do
			tmp = tmp .. k .. "=" .. v .. ",";
		end;
		self:ClockModColorTitle(tmp);

		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			ClockModColorTitle(Parameter);
		end;
	end;

end;

----
-- Ändert die Farbe der Schrift für den Titel der Spielzeiten
----
function ClockMod:ClockModColorTitle(Parameter)

	if Parameter ~= nil then
 		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen ClockModColorTitle Hilfe
			print("Ändert die Farbe für die Bezeichnung von Spielzeit");
			print("Beispiel: ");
			print("ClockModColorTitle r=1,g=1,b=1,a=1 | ändert alle Farben und den Transparentswert der Schrift");
			print("ClockModColorTitle r=1,g=1,b=1 | ändert nur die Farben");
			print("ClockModColorTitle r=1,g=1 | ändert nur den Rot und Grün anteil der Farbe");
			print("ClockModColorTitle r=1 | ändert nur den Rot Anteil der Farbe");
		else
		   for k, v in string.gfind(Parameter, "([rgba])=([0-9.]+)") do
				if tonumber(v) > 1 then
					print("Der Farbwert sollte zwischen 0 und 1 liegen, Für RGB Werte bitte die Funktion ClockModColorTitleRGB verwenden");
				else
					self.txtColors.title[k] = tonumber(v);
					print(string.format("Neuer Farbe für : %s=%.3f", k, v));
				end;
			end;
		end;
	else
        for k, v in pairs(self.txtColors.title) do
			print(string.format("Aktueller Wert Textfarbe für : %s=%.3f", k, v));
        end;
	end;

end;
----

----
-- Ausführung von Konsolen Befehlen
----
function ClockMod:ClockModColorTextRGB(Parameter)

	local myTable = {};
	if Parameter ~= nil then
		local pw = 0;
        for k, v in string.gfind(Parameter, "([rgba])=([0-9]+)") do
			pw = v/255;
            myTable[k] = tonumber(v);
        end;
		local tmp = "";
		for k,v in pairs(myTable) do
			tmp = tmp .. k .. "=" .. v .. ",";
		end;
		self:ClockModColorText(tmp);

		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			ClockModColorText(Parameter);
		end;
	end;

end;

----
-- Ändert die Farbe der Schrift für die Anzeige der Spielzeiten
----
function ClockMod:ClockModColorText(Parameter)

	if Parameter ~= nil then
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen ClockModColorText Hilfe
			print("Ändert die Farbe für die Spielzeit");
			print("Beispiel: ");
			print("ClockModColorText r=1,g=1,b=1,a=1 | ändert alle Farben und den Transparentswert der Schrift");
			print("ClockModColorText r=1,g=1,b=1 | ändert nur die Farben");
			print("ClockModColorText r=1,g=1 | ändert nur den Rot und Grün anteil der Farbe");
			print("ClockModColorText r=1 | ändert nur den Rot Anteil der Farbe");
		else
			for k, v in string.gfind(Parameter, "([rgba])=([0-9.]+)") do
				if tonumber(v) > 1 then
					print("Der Farbwert sollte zwischen 0 und 1 liegen, Für RGB Werte bitte die Funktion ClockModColorDateRGB verwenden");
				else
					self.txtColors.data[k] = tonumber(v);
					print(string.format("Neuer Farbe für : %s=%.3f", k, v));
				end;
			end;
		end;
	else
        for k, v in pairs(self.txtColors.data) do
			print(string.format("Aktueller Wert Textfarbe für : %s=%.3f", k, v));
        end;
	end;

end;
----

----
-- Ausführung von Konsolen Befehlen
----
function ClockMod:ClockModColorCompassRGB(Parameter)

	local myTable = {};
	if Parameter ~= nil then
		local pw = 0;
        for k, v in string.gfind(Parameter, "([rgba])=([0-9]+)") do
			pw = v/255;
            myTable[k] = tonumber(v);
        end;
		local tmp = "";
		for k,v in pairs(myTable) do
			tmp = tmp .. k .. "=" .. v .. ",";
		end;
		self:ClockModColorCompass(tmp);

		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			ClockModColorCompass(Parameter);
		end;
	end;

end;

----
-- Ändert die Farbe der Schrift für die Anzeige der Spielzeiten
----
function ClockMod:ClockModColorCompass(Parameter)

	if Parameter ~= nil then
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- TODO: Übersetzen ClockModColorCompass Hilfe
			print("Ändert die Farbe für die Spielzeit");
			print("Beispiel: ");
			print("ClockModColorCompass r=1,g=1,b=1,a=1 | ändert alle Farben und den Transparentswert der Schrift");
			print("ClockModColorCompass r=1,g=1,b=1 | ändert nur die Farben");
			print("ClockModColorCompass r=1,g=1 | ändert nur den Rot und Grün anteil der Farbe");
			print("ClockModColorCompass r=1 | ändert nur den Rot Anteil der Farbe");
		else
			for k, v in string.gfind(Parameter, "([rgba])=([0-9.]+)") do
				if tonumber(v) > 1 then
					print("Der Farbwert sollte zwischen 0 und 1 liegen, Für RGB Werte bitte die Funktion ClockModColorCompassRGB verwenden");
				else
					self.txtColors.data[k] = tonumber(v);
					print(string.format("Neuer Farbe für : %s=%.3f", k, v));
				end;
			end;
		end;
	else
        for k, v in pairs(self.txtColors.data) do
			print(string.format("Aktueller Wert Textfarbe für : %s=%.3f", k, v));
        end;
	end;

end;
----

----
--	Ändert die Schriftgröße
----
function ClockMod:ClockModFontSize(Parameter)
	-- TODO: Übersetzen ClockModFontSize Hilfe
	-- TODO: Parameter Angabe in Hilfetext
	if Parameter ~= nil then
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			print("Setzen der Fontgröße");
			print("Aufruf: ClockModFontSize 0 bis 1");
			return;
        else
			for k, v in string.gfind(Parameter, "(%w+)=([0-9.]+)") do
				self.cmPanel.fontsize[k] = tonumber(v);
				print(string.format("Neue Fontgröße für : %s=%.3f", k, v));
			end;
			self:setPanelMidHeight();
		end;
	else
        for k, v in pairs(self.cmPanel.fontsize) do
			print(string.format("Aktueller Wert Fontgröße für : %s=%.3f", k, v));
        end;
	end;
end;
----

----
--	Ändert den Abstand des Text vom linken Panelrand
----
function ClockMod:ClockModFontIndent(Parameter)
	-- TODO: Übersetzen ClockModFontIndent Hilfe
	-- TODO: Parameter Angabe in Hilfetext
	if Parameter ~= nil then
		if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			print("Setzen der Schrifteinzug");
			print("Aufruf: ClockModFontIndent 0 bis 1");
			return;
        end;
        for k, v in string.gfind(Parameter, "(%w+)=([0-9.]+)") do
            self.cmPanel.indent[k] = tonumber(v);
			print(string.format("Neuer Schrifteinzug für : %s=%.3f", k, v));
        end;
	else
        for k, v in pairs(self.cmPanel.indent) do
			print(string.format("Aktueller Wert Schrifteinzug für : %s=%.3f", k, v));
        end;
	end;
end;
----

----
-- Setzt einen Wecker auf eine Uhrzeit
----
function ClockMod:ClockModAlarm(Parameter)

	-- if Parameter ~= nil then
		-- if string.lower(Parameter) == "1" or string.lower(Parameter) == "true" then
			-- self.cmAlarm.time.enabled = true;
		-- elseif string.lower(Parameter) == "0" or string.lower(Parameter) == "false" then
			-- self.cmAlarm.time.enabled = false;
		-- end;

		-- if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- print("Setzt einen Alarm als Countdown");
			-- print("Aufruf: ClockModAlarm 1 oder 0 zum aktivieren bzw. deaktivieren");
			-- print("ClockModAlarm [Zeit in Mnuten] um die Anzahl der Minuten zu setzen");
		-- end;

	-- end;
	--- return string.format("ClockMod Alarm is set to %s and at %s", tostring(self.cmAlarm.time.enabled), tostring(Parameter));
	return "Funktion ist noch nicht implementiert / function not yet ready";
end;
----

----
-- Setzt einen Countdown auf die Anzahl von Minuten
----
function ClockMod:ClockModTimer(Parameter)

	-- if Parameter ~= nil then
		-- if string.lower(Parameter) == "1" or string.lower(Parameter) == "true" then
			-- self.cmCounter.time.enabled = true;
		-- elseif string.lower(Parameter) == "0" or string.lower(Parameter) == "false" then
			-- self.cmCounter.time.enabled = false;
		-- end;

		-- if string.lower(Parameter) == "help" or string.lower(Parameter) == "-?" or string.lower(Parameter) == "-h" then
			-- print("Setzt einen Alarm als Countdown");
			-- print("Aufruf: ClockModTimer 1 oder 0 zum aktivieren bzw. deaktivieren");
			-- print("ClockModTimer [Zeit in Mnuten] um die Anzahl der Minuten zu setzen");
		-- end;
	-- end;
	----
	-- return string.format("ClockMod Timer is set to %s and for %s minutes", tostring(self.cmCounter.time.enabled), tostring(Parameter));
	return "Funktion ist noch nicht implementiert / function not yet ready";
end;
----

